Index: src/datacreator.cpp
===================================================================
--- src/datacreator.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/datacreator.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -19,12 +19,12 @@
 bool OpenOutputFile(ofstream &output, const char *dir, const char *filename)
 {
-	stringstream name;
-	name << dir << "/" << filename;
-	output.open(name.str().c_str(), ios::out);
-	if (output == NULL) {
-		cout << "Unable to open " << name.str() << " for writing, is directory correct?" << endl;
-		return false;
-	}
-	return true;
+  stringstream name;
+  name << dir << "/" << filename;
+  output.open(name.str().c_str(), ios::out);
+  if (output == NULL) {
+    cout << "Unable to open " << name.str() << " for writing, is directory correct?" << endl;
+    return false;
+  }
+  return true;
 };
 
@@ -37,12 +37,12 @@
 bool AppendOutputFile(ofstream &output, const char *dir, const char *filename)
 {
-	stringstream name;
-	name << dir << "/" << filename;
-	output.open(name.str().c_str(), ios::app);
-	if (output == NULL) {
-		cout << "Unable to open " << name.str() << " for writing, is directory correct?" << endl;
-		return false;
-	}
-	return true;
+  stringstream name;
+  name << dir << "/" << filename;
+  output.open(name.str().c_str(), ios::app);
+  if (output == NULL) {
+    cout << "Unable to open " << name.str() << " for writing, is directory correct?" << endl;
+    return false;
+  }
+  return true;
 };
 
@@ -56,25 +56,25 @@
 bool CreateDataEnergyOrder(class EnergyMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum)
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "#Order\tFrag.No.\t" << Fragments.Header << endl;
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		for(int i=KeySet.FragmentsPerOrder[BondOrder];i--;) {
-			for(int j=Fragments.RowCounter[ KeySet.OrderSet[BondOrder][i] ];j--;)
-				for(int k=Fragments.ColumnCounter;k--;)
-					Fragments.Matrix[Fragments.MatrixCounter][j][k] += Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
-		}
-		output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
-		for (int l=0;l<Fragments.ColumnCounter;l++)
-			output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter]-1 ][l];
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "#Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    for(int i=KeySet.FragmentsPerOrder[BondOrder];i--;) {
+      for(int j=Fragments.RowCounter[ KeySet.OrderSet[BondOrder][i] ];j--;)
+        for(int k=Fragments.ColumnCounter[ KeySet.OrderSet[BondOrder][i] ];k--;)
+          Fragments.Matrix[Fragments.MatrixCounter][j][k] += Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
+    }
+    output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
+    for (int l=0;l<Fragments.ColumnCounter[Fragments.MatrixCounter];l++)
+      output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter]-1 ][l];
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -89,29 +89,29 @@
 bool CreateDataDeltaEnergyOrder(class EnergyMatrix &Energy, class EnergyMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum)
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "#Order\tFrag.No.\t" << Fragments.Header << endl;
-	Fragments.SetLastMatrix(Energy.Matrix[Energy.MatrixCounter],0);
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		for(int i=KeySet.FragmentsPerOrder[BondOrder];i--;) {
-			for(int j=Fragments.RowCounter[ KeySet.OrderSet[BondOrder][i] ];j--;)
-				for(int k=Fragments.ColumnCounter;k--;)
-					Fragments.Matrix[Fragments.MatrixCounter][j][k] -= Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
-		}
-		output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
-		for (int l=0;l<Fragments.ColumnCounter;l++)
-			if (fabs(Energy.Matrix[Energy.MatrixCounter][ Energy.RowCounter[Energy.MatrixCounter]-1 ][l]) < MYEPSILON)
-				output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter]-1 ][l];
-			else
-				output << scientific << "\t" << (Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter]-1 ][l] / Energy.Matrix[Energy.MatrixCounter][ Energy.RowCounter[Energy.MatrixCounter]-1 ][l]);
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "#Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  Fragments.SetLastMatrix(Energy.Matrix[Energy.MatrixCounter],0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    for(int i=KeySet.FragmentsPerOrder[BondOrder];i--;) {
+      for(int j=Fragments.RowCounter[ KeySet.OrderSet[BondOrder][i] ];j--;)
+        for(int k=Fragments.ColumnCounter[ KeySet.OrderSet[BondOrder][i] ];k--;)
+          Fragments.Matrix[Fragments.MatrixCounter][j][k] -= Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
+    }
+    output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
+    for (int l=0;l<Fragments.ColumnCounter[Energy.MatrixCounter];l++)
+      if (fabs(Energy.Matrix[Energy.MatrixCounter][ Energy.RowCounter[Energy.MatrixCounter]-1 ][l]) < MYEPSILON)
+        output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter]-1 ][l];
+      else
+        output << scientific << "\t" << (Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter]-1 ][l] / Energy.Matrix[Energy.MatrixCounter][ Energy.RowCounter[Energy.MatrixCounter]-1 ][l]);
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -126,23 +126,23 @@
 bool CreateDataForcesOrder(class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix,const  char *msg, const char *datum, void (*CreateForce)(class MatrixContainer &, int))
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "# Order\tFrag.No.\t" << Fragments.Header << endl;
-	Fragments.SetLastMatrix(0.,0);
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		Fragments.SumSubForces(Fragments, KeySet, BondOrder, 1.);
-		output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
-		CreateForce(Fragments, Fragments.MatrixCounter);
-		for (int l=0;l<Fragments.ColumnCounter;l++)
-			 output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter] ][l];
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  Fragments.SetLastMatrix(0.,0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    Fragments.SumSubForces(Fragments, KeySet, BondOrder, 1.);
+    output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
+    CreateForce(Fragments, Fragments.MatrixCounter);
+    for (int l=0;l<Fragments.ColumnCounter[Fragments.MatrixCounter];l++)
+       output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter] ][l];
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -158,23 +158,23 @@
 bool CreateDataDeltaForcesOrder(class ForceMatrix &Force, class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum, void (*CreateForce)(class MatrixContainer &, int))
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "# Order\tFrag.No.\t" << Fragments.Header << endl;
-	Fragments.SetLastMatrix(Force.Matrix[Force.MatrixCounter],0);
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		Fragments.SumSubForces(Fragments, KeySet, BondOrder, -1.);
-		output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
-		CreateForce(Fragments, Fragments.MatrixCounter);
-		for (int l=0;l<Fragments.ColumnCounter;l++)
-			 output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter] ][l];
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  Fragments.SetLastMatrix(Force.Matrix[Force.MatrixCounter],0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    Fragments.SumSubForces(Fragments, KeySet, BondOrder, -1.);
+    output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
+    CreateForce(Fragments, Fragments.MatrixCounter);
+    for (int l=0;l<Fragments.ColumnCounter[Fragments.MatrixCounter];l++)
+       output << scientific << "\t" << Fragments.Matrix[Fragments.MatrixCounter][ Fragments.RowCounter[Fragments.MatrixCounter] ][l];
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -190,39 +190,39 @@
 bool CreateDataDeltaForcesOrderPerAtom(class ForceMatrix &Force, class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum)
 {
-	stringstream filename;
-	ofstream output;
-	double norm = 0.;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "# AtomNo\t" << Fragments.Header << endl;
-	Fragments.SetLastMatrix(Force.Matrix[Force.MatrixCounter], 0);
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		//cout << "Current order is " << BondOrder << "." << endl;
-		Fragments.SumSubForces(Fragments, KeySet, BondOrder, -1.);
-		// errors per atom
-		output << endl << "#Order\t" << BondOrder+1 << endl;
-		for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) {
-			output << Fragments.Indices[Fragments.MatrixCounter][j] << "\t";
-			for (int l=0;l<Fragments.ColumnCounter;l++) {
-				if (((l+1) % 3) == 0) {
-					norm = 0.;
-					for (int m=0;m<NDIM;m++)
-						norm += Force.Matrix[Force.MatrixCounter][ j ][l+m]*Force.Matrix[Force.MatrixCounter][ j ][l+m];
-					norm = sqrt(norm);
-				}
-//				if (norm < MYEPSILON)
-					output << scientific << Fragments.Matrix[Fragments.MatrixCounter][ j ][l] << "\t";
-//				else
-//					output << scientific << (Fragments.Matrix[Fragments.MatrixCounter][ j ][l] / norm) << "\t";
-			}
-			output << endl;
-		}
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+  double norm = 0.;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# AtomNo\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  Fragments.SetLastMatrix(Force.Matrix[Force.MatrixCounter], 0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    //cout << "Current order is " << BondOrder << "." << endl;
+    Fragments.SumSubForces(Fragments, KeySet, BondOrder, -1.);
+    // errors per atom
+    output << endl << "#Order\t" << BondOrder+1 << endl;
+    for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) {
+      output << Fragments.Indices[Fragments.MatrixCounter][j] << "\t";
+      for (int l=0;l<Fragments.ColumnCounter[ Fragments.MatrixCounter ];l++) {
+        if (((l+1) % 3) == 0) {
+          norm = 0.;
+          for (int m=0;m<NDIM;m++)
+            norm += Force.Matrix[Force.MatrixCounter][ j ][l+m]*Force.Matrix[Force.MatrixCounter][ j ][l+m];
+          norm = sqrt(norm);
+        }                                                                                                    
+//        if (norm < MYEPSILON)
+          output << scientific << Fragments.Matrix[Fragments.MatrixCounter][ j ][l] << "\t";
+//        else
+//          output << scientific << (Fragments.Matrix[Fragments.MatrixCounter][ j ][l] / norm) << "\t";
+      }
+      output << endl;
+    }
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -237,27 +237,147 @@
 bool CreateDataForcesOrderPerAtom(class ForceMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum)
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "# AtomNo\t" << Fragments.Header << endl;
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		//cout << "Current order is " << BondOrder << "." << endl;
-		Fragments.SumSubForces(Fragments, KeySet, BondOrder, 1.);
-		// errors per atom
-		output << endl << "#Order\t" << BondOrder+1 << endl;
-		for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) {
-			output << Fragments.Indices[Fragments.MatrixCounter][j] << "\t";
-			for (int l=0;l<Fragments.ColumnCounter;l++)
-				output << scientific << Fragments.Matrix[Fragments.MatrixCounter][ j ][l] << "\t";
-			output << endl;
-		}
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# AtomNo\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    //cout << "Current order is " << BondOrder << "." << endl;
+    Fragments.SumSubForces(Fragments, KeySet, BondOrder, 1.);
+    // errors per atom
+    output << endl << "#Order\t" << BondOrder+1 << endl;
+    for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) {
+      output << Fragments.Indices[Fragments.MatrixCounter][j] << "\t";
+      for (int l=0;l<Fragments.ColumnCounter[ Fragments.MatrixCounter ];l++)
+        output << scientific << Fragments.Matrix[Fragments.MatrixCounter][ j ][l] << "\t";
+      output << endl;
+    }
+    output << endl;
+  }
+  output.close();
+  return true;
+};
+
+
+/** Plot hessian error vs. vs atom vs. order.
+ * \param &Hessian HessianMatrix containing reference values (in MatrixCounter matrix)
+ * \param &Fragments HessianMatrix class containing matrix values
+ * \param KeySet KeySetContainer class holding bond KeySetContainer::Order
+ * \param *prefix prefix in filename (without ending)
+ * \param *msg message to be place in first line as a comment
+ * \param *datum current date and time
+ * \return true if file was written successfully
+ */
+bool CreateDataDeltaHessianOrderPerAtom(class HessianMatrix &Hessian, class HessianMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum) 
+{
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false; 
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# AtomNo\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
+  Fragments.SetLastMatrix(Hessian.Matrix[Hessian.MatrixCounter], 0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    //cout << "Current order is " << BondOrder << "." << endl;
+    Fragments.SumSubHessians(Fragments, KeySet, BondOrder, -1.);
+    // errors per atom
+    output << endl << "#Order\t" << BondOrder+1 << endl;
+    for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) { 
+      output << Fragments.Indices[Fragments.MatrixCounter][j] << "\t";
+      for (int l=0;l<Fragments.ColumnCounter[ Fragments.MatrixCounter ];l++) {
+        output << scientific << Fragments.Matrix[Fragments.MatrixCounter][ j ][l] << "\t";
+      }
+      output << endl;
+    }
+    output << endl;
+  }
+  output.close();
+  return true;
+};
+
+/** Plot hessian error vs. vs atom vs. order in the frobenius norm.
+ * \param &Hessian HessianMatrix containing reference values (in MatrixCounter matrix)
+ * \param &Fragments HessianMatrix class containing matrix values
+ * \param KeySet KeySetContainer class holding bond KeySetContainer::Order
+ * \param *prefix prefix in filename (without ending)
+ * \param *msg message to be place in first line as a comment
+ * \param *datum current date and time
+ * \return true if file was written successfully
+ */
+bool CreateDataDeltaFrobeniusOrderPerAtom(class HessianMatrix &Hessian, class HessianMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum) 
+{
+  stringstream filename;
+  ofstream output;
+  double norm = 0;
+  double tmp;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false; 
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# AtomNo\t";
+  Fragments.SetLastMatrix(Hessian.Matrix[Hessian.MatrixCounter], 0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    output << "Order" << BondOrder+1 << "\t";
+  }
+  output << endl;
+  output << Fragments.RowCounter[ Fragments.MatrixCounter ] << "\t";
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    //cout << "Current order is " << BondOrder << "." << endl;
+    Fragments.SumSubHessians(Fragments, KeySet, BondOrder, -1.);
+    // frobenius norm of errors per atom
+    norm = 0.;
+    for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) { 
+      for (int l=0;l<Fragments.ColumnCounter[ Fragments.MatrixCounter ];l++) {
+        tmp = Fragments.Matrix[Fragments.MatrixCounter][ j ][l];
+        norm += tmp*tmp;
+      }
+    }
+    output << scientific << sqrt(norm)/(Fragments.RowCounter[ Fragments.MatrixCounter ]*Fragments.ColumnCounter[ Fragments.MatrixCounter] ) << "\t";
+  }
+  output << endl;
+  output.close();
+  return true;
+};
+
+/** Plot hessian error vs. vs atom vs. order.
+ * \param &Fragments HessianMatrix class containing matrix values
+ * \param KeySet KeySetContainer class holding bond KeySetContainer::Order
+ * \param *prefix prefix in filename (without ending)
+ * \param *msg message to be place in first line as a comment
+ * \param *datum current date and time
+ * \return true if file was written successfully
+ */
+bool CreateDataHessianOrderPerAtom(class HessianMatrix &Fragments, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum) 
+{
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false; 
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "# AtomNo\t" << Fragments.Header[ Fragments.MatrixCounter ] << endl;
+  Fragments.SetLastMatrix(0., 0);
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    //cout << "Current order is " << BondOrder << "." << endl;
+    Fragments.SumSubHessians(Fragments, KeySet, BondOrder, 1.);
+    // errors per atom
+    output << endl << "#Order\t" << BondOrder+1 << endl;
+    for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) { 
+      output << Fragments.Indices[Fragments.MatrixCounter][j] << "\t";
+      for (int l=0;l<Fragments.ColumnCounter[ Fragments.MatrixCounter ];l++)
+        output << scientific << Fragments.Matrix[Fragments.MatrixCounter][ j ][l] << "\t";
+      output << endl;
+    }
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -266,23 +386,23 @@
 bool CreateDataFragment(class MatrixContainer &Fragment, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum, void (*CreateFragment)(class MatrixContainer &, int))
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum << endl;
-	output << "#Order\tFrag.No.\t" << Fragment.Header << endl;
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		for(int i=0;i<KeySet.FragmentsPerOrder[BondOrder];i++) {
-			output << BondOrder+1 << "\t" << KeySet.OrderSet[BondOrder][i]+1;
-			CreateFragment(Fragment, KeySet.OrderSet[BondOrder][i]);
-			for (int l=0;l<Fragment.ColumnCounter;l++)
-				output << scientific << "\t" << Fragment.Matrix[ KeySet.OrderSet[BondOrder][i] ][ Fragment.RowCounter[ KeySet.OrderSet[BondOrder][i] ] ][l];
-			output << endl;
-		}
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum << endl;
+  output << "#Order\tFrag.No.\t" << Fragment.Header[ Fragment.MatrixCounter ] << endl;
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    for(int i=0;i<KeySet.FragmentsPerOrder[BondOrder];i++) {
+      output << BondOrder+1 << "\t" << KeySet.OrderSet[BondOrder][i]+1;
+      CreateFragment(Fragment, KeySet.OrderSet[BondOrder][i]);
+      for (int l=0;l<Fragment.ColumnCounter[ KeySet.OrderSet[BondOrder][i] ];l++)
+        output << scientific << "\t" << Fragment.Matrix[ KeySet.OrderSet[BondOrder][i] ][ Fragment.RowCounter[ KeySet.OrderSet[BondOrder][i] ] ][l];
+      output << endl;
+    }
+  }
+  output.close();
+  return true;
 };
 
@@ -294,12 +414,12 @@
 void CreateMaxFragmentOrder(class MatrixContainer &Fragments, class KeySetsContainer &KeySet, int BondOrder)
 {
-	for(int j=Fragments.RowCounter[ Fragments.MatrixCounter ];j--;) {
-		for(int i=KeySet.FragmentsPerOrder[BondOrder];i--;) {
-			if (fabs(Fragments.Matrix[ Fragments.MatrixCounter ][j][1]) < fabs(Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][1])) {
-				for (int k=Fragments.ColumnCounter;k--;)
-					Fragments.Matrix[ Fragments.MatrixCounter ][j][k] = Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
-			}
-		}
-	}
+  for(int j=Fragments.RowCounter[ Fragments.MatrixCounter ];j--;) {
+    for(int i=KeySet.FragmentsPerOrder[BondOrder];i--;) {
+      if (fabs(Fragments.Matrix[ Fragments.MatrixCounter ][j][1]) < fabs(Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][1])) {
+        for (int k=Fragments.ColumnCounter[ Fragments.MatrixCounter ];k--;)
+          Fragments.Matrix[ Fragments.MatrixCounter ][j][k] = Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
+      }
+    }
+  }
 };
 
@@ -311,18 +431,18 @@
 void CreateMinFragmentOrder(class MatrixContainer &Fragments, class KeySetsContainer &KeySet, int BondOrder)
 {
-	for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) {
-		int i=0;
-		do {	// first get a minimum value unequal to 0
-			for (int k=Fragments.ColumnCounter;k--;)
-				Fragments.Matrix[ Fragments.MatrixCounter ][j][k] = Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
-			i++;
-		} while ((fabs(Fragments.Matrix[ Fragments.MatrixCounter ][j][1]) < MYEPSILON) && (i<KeySet.FragmentsPerOrder[BondOrder]));
-		for(;i<KeySet.FragmentsPerOrder[BondOrder];i++) { // then find lowest
-			if (fabs(Fragments.Matrix[ Fragments.MatrixCounter ][j][1]) > fabs(Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][1])) {
-				for (int k=Fragments.ColumnCounter;k--;)
-					Fragments.Matrix[ Fragments.MatrixCounter ][j][k] = Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
-			}
-		}
-	}
+  for(int j=0;j<Fragments.RowCounter[ Fragments.MatrixCounter ];j++) {
+    int i=0;
+    do {  // first get a minimum value unequal to 0
+      for (int k=Fragments.ColumnCounter[ Fragments.MatrixCounter ];k--;)
+        Fragments.Matrix[ Fragments.MatrixCounter ][j][k] = Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
+      i++;
+    } while ((fabs(Fragments.Matrix[ Fragments.MatrixCounter ][j][1]) < MYEPSILON) && (i<KeySet.FragmentsPerOrder[BondOrder]));
+    for(;i<KeySet.FragmentsPerOrder[BondOrder];i++) { // then find lowest
+      if (fabs(Fragments.Matrix[ Fragments.MatrixCounter ][j][1]) > fabs(Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][1])) {
+        for (int k=Fragments.ColumnCounter[ Fragments.MatrixCounter ];k--;)
+          Fragments.Matrix[ Fragments.MatrixCounter ][j][k] = Fragments.Matrix[ KeySet.OrderSet[BondOrder][i] ][j][k];
+      }
+    }
+  }
 };
 
@@ -331,23 +451,23 @@
 bool CreateDataFragmentOrder(class MatrixContainer &Fragment, class KeySetsContainer &KeySet, const char *dir, const char *prefix, const char *msg, const char *datum, void (*CreateFragmentOrder)(class MatrixContainer &, class KeySetsContainer &, int))
 {
-	stringstream filename;
-	ofstream output;
-
-	filename << prefix << ".dat";
-	if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-	cout << msg << endl;
-	output << "# " << msg << ", created on " << datum;
-	output << "#Order\tFrag.No.\t" << Fragment.Header << endl;
-	// max
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		Fragment.SetLastMatrix(0.,0);
-		CreateFragmentOrder(Fragment, KeySet, BondOrder);
-		output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
-		for (int l=0;l<Fragment.ColumnCounter;l++)
-			output << scientific << "\t" << Fragment.Matrix[ Fragment.MatrixCounter ][ Fragment.RowCounter[ Fragment.MatrixCounter ]-1 ][l];
-		output << endl;
-	}
-	output.close();
-	return true;
+  stringstream filename;
+  ofstream output;
+
+  filename << prefix << ".dat";
+  if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
+  cout << msg << endl;
+  output << "# " << msg << ", created on " << datum;
+  output << "#Order\tFrag.No.\t" << Fragment.Header[ Fragment.MatrixCounter ] << endl;
+  // max
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    Fragment.SetLastMatrix(0.,0);
+    CreateFragmentOrder(Fragment, KeySet, BondOrder);
+    output << BondOrder+1 << "\t" << KeySet.FragmentsPerOrder[BondOrder];
+    for (int l=0;l<Fragment.ColumnCounter[ Fragment.MatrixCounter ];l++)
+      output << scientific << "\t" << Fragment.Matrix[ Fragment.MatrixCounter ][ Fragment.RowCounter[ Fragment.MatrixCounter ]-1 ][l];
+    output << endl;
+  }
+  output.close();
+  return true;
 };
 
@@ -358,6 +478,6 @@
 void CreateEnergy(class MatrixContainer &Energy, int MatrixNumber)
 {
-	for(int k=0;k<Energy.ColumnCounter;k++)
-		Energy.Matrix[MatrixNumber][ Energy.RowCounter[MatrixNumber] ] [k] =	Energy.Matrix[MatrixNumber][ Energy.RowCounter[MatrixNumber]-1 ] [k];
+  for(int k=0;k<Energy.ColumnCounter[MatrixNumber];k++)
+    Energy.Matrix[MatrixNumber][ Energy.RowCounter[MatrixNumber] ] [k] =  Energy.Matrix[MatrixNumber][ Energy.RowCounter[MatrixNumber]-1 ] [k];
 };
 
@@ -369,29 +489,29 @@
 void CreateMinimumForce(class MatrixContainer &Force, int MatrixNumber)
 {
-	for (int l=Force.ColumnCounter;l--;)
-		Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = 0.;
-	for (int l=5;l<Force.ColumnCounter;l+=3) {
-		double stored = 0;
-		int k=0;
-		do {
-			for (int m=NDIM;m--;) {
-				stored += Force.Matrix[MatrixNumber][ k ][l+m]
-							* Force.Matrix[MatrixNumber][ k ][l+m];
-				Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l+m]	= Force.Matrix[MatrixNumber][ k ][l+m];
-			}
-			k++;
-		} while ((fabs(stored) < MYEPSILON) && (k<Force.RowCounter[MatrixNumber]));
-		for (;k<Force.RowCounter[MatrixNumber];k++) {
-			double tmp = 0;
-			for (int m=NDIM;m--;)
-				tmp += Force.Matrix[MatrixNumber][ k ][l+m]
-							* Force.Matrix[MatrixNumber][ k ][l+m];
-			if ((fabs(tmp) > MYEPSILON) && (tmp < stored)) {	// current force is greater than stored
-				for (int m=NDIM;m--;)
-					Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l+m]	= Force.Matrix[MatrixNumber][ k ][l+m];
-				stored = tmp;
-			}
-		}
-	}
+  for (int l=Force.ColumnCounter[MatrixNumber];l--;)
+    Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l] = 0.;
+  for (int l=5;l<Force.ColumnCounter[MatrixNumber];l+=3) {
+    double stored = 0;
+    int k=0;
+    do {
+      for (int m=NDIM;m--;) {
+        stored += Force.Matrix[MatrixNumber][ k ][l+m]
+              * Force.Matrix[MatrixNumber][ k ][l+m];
+        Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l+m]  = Force.Matrix[MatrixNumber][ k ][l+m];
+      }
+      k++;
+    } while ((fabs(stored) < MYEPSILON) && (k<Force.RowCounter[MatrixNumber]));
+    for (;k<Force.RowCounter[MatrixNumber];k++) {
+      double tmp = 0;
+      for (int m=NDIM;m--;)
+        tmp += Force.Matrix[MatrixNumber][ k ][l+m]
+              * Force.Matrix[MatrixNumber][ k ][l+m];
+      if ((fabs(tmp) > MYEPSILON) && (tmp < stored)) {  // current force is greater than stored
+        for (int m=NDIM;m--;)
+          Force.Matrix[MatrixNumber][ Force.RowCounter[MatrixNumber] ][l+m]  = Force.Matrix[MatrixNumber][ k ][l+m];
+        stored = tmp;
+      }
+    }
+  }
 };
 
